# Copyright (C) 2013, Eric Wong <normalperson@yhbt.net> and all contributors
# License: GPLv3 or later (https://www.gnu.org/licenses/gpl-3.0.txt)
#
# POSIX pipe version, see queue_quitter.rb for the (preferred) eventfd one
class Yahns::QueueQuitter # :nodoc:
  attr_reader :to_io
  def initialize
    @reader, @to_io = IO.pipe
    @to_io.close_on_exec = true
  end

  def yahns_step
    Thread.current.exit
  end

  def fileno
    @to_io.fileno
  end

  def close
    @reader.close
    @to_io.close
  end
end
